-- sprite_core.e - sprite routines for the sprite engine developer.
-- Copyright (C)2004 Hayden McKay. FREEWARE use freely.

-- If you use this library as part of a sprite engine please e-mail
-- me a copy. If you would like some help implementing the routines
-- into a skeleton or an already developed sprite engine just  mail
-- me. I'll be glad to help.

-- E-Mail: hayden_mckay@hotmail.com
-- Please e-mail any requests and I'll think about codeing them in.

-- *This library is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY;   without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
-- Lesser General Public License for more details.

include bits.e

sequence
il_code
il_code={
#55,#89,#E5,#53,#51,#52,#9C,#58,#89,#C1,#35,#00,#00,#20,#00,#50,#9D,#9C,#58,#31,
#C8,#75,#04,#31,#C0,#EB,#18,#B8,#01,#00,#00,#00,#0F,#A2,#F7,#C2,#00,#00,#80,#00,
#75,#04,#31,#C0,#EB,#05,#B8,#01,#00,#00,#00,#5A,#59,#5B,#C9,#C2,#00,#00,#55,#89,
#E5,#51,#52,#57,#56,#8B,#55,#08,#8B,#75,#0C,#8B,#7D,#10,#8B,#4D,#14,#0F,#6F,#02,
#0F,#EF,#FF,#0F,#6F,#0E,#0F,#74,#F8,#83,#E9,#08,#0F,#DB,#F9,#83,#C7,#08,#0F,#EF,
#F8,#83,#C6,#08,#0F,#7F,#7F,#F8,#83,#C2,#08,#83,#F9,#00,#74,#02,#EB,#D7,#90,#0F,
#77,#5E,#5F,#5A,#59,#89,#EC,#5D,#C3,#55,#89,#E5,#50,#53,#51,#52,#57,#56,#8B,#55,
#08,#8B,#75,#0C,#8B,#7D,#10,#8B,#4D,#14,#8A,#02,#8A,#1E,#3C,#00,#75,#03,#88,#D8,
#90,#88,#07,#83,#E9,#01,#83,#C2,#01,#83,#C6,#01,#83,#C7,#01,#83,#F9,#00,#74,#02,
#EB,#E0,#5E,#5F,#5A,#59,#5B,#58,#89,#EC,#5D,#C3,#55,#89,#E5,#50,#53,#51,#52,#57,
#56,#8B,#75,#08,#8B,#7D,#0C,#8B,#45,#10,#8B,#5D,#14,#8B,#4D,#18,#29,#C1,#89,#C2,
#83,#FB,#00,#74,#2B,#83,#EB,#01,#0F,#6F,#06,#0F,#EF,#FF,#0F,#6F,#0F,#0F,#74,#F8,
#83,#EA,#08,#0F,#DB,#F9,#83,#C7,#08,#0F,#EF,#F8,#83,#C6,#08,#0F,#7F,#7F,#F8,#83,
#FA,#00,#75,#DC,#01,#CF,#EB,#CE,#90,#0F,#77,#5E,#5F,#5A,#59,#5B,#58,#89,#EC,#5D,
#C3,#55,#89,#E5,#50,#53,#51,#52,#57,#56,#8B,#75,#08,#8B,#7D,#0C,#8B,#45,#10,#8B,
#5D,#14,#8B,#4D,#18,#29,#C1,#90,#29,#CF,#8B,#45,#10,#83,#FB,#00,#74,#21,#83,#EB,
#01,#01,#CF,#90,#83,#F8,#00,#74,#ED,#83,#C6,#01,#83,#C7,#01,#8A,#56,#FF,#83,#E8,
#01,#80,#FA,#00,#74,#EA,#88,#57,#FF,#EB,#E5,#5E,#5F,#5A,#59,#5B,#58,#89,#EC,#5D,
#C3,#55,#89,#E5,#50,#53,#51,#52,#57,#56,#8B,#75,#08,#8B,#7D,#0C,#8B,#45,#10,#8B,
#5D,#14,#8B,#4D,#18,#29,#C1,#90,#29,#CF,#83,#FB,#00,#74,#1E,#89,#C2,#83,#EB,#01,
#01,#CF,#90,#0F,#6F,#06,#83,#EA,#08,#0F,#7F,#07,#83,#C6,#08,#83,#C7,#08,#83,#FA,
#00,#74,#DF,#EB,#EA,#90,#0F,#77,#5E,#5F,#5A,#59,#5B,#58,#89,#EC,#5D,#C3,#55,#89,
#E5,#50,#53,#51,#52,#57,#56,#8B,#75,#08,#8B,#7D,#0C,#8B,#45,#10,#8B,#5D,#14,#8B,
#4D,#18,#29,#C1,#90,#29,#CF,#83,#FB,#00,#74,#1D,#8B,#55,#10,#83,#EB,#01,#01,#CF,
#90,#8B,#06,#83,#EA,#04,#89,#07,#83,#C6,#04,#83,#C7,#04,#83,#FA,#00,#74,#E0,#EB,
#EC,#5E,#5F,#5A,#59,#5B,#58,#89,#EC,#5D,#C3,#55,#89,#E5,#53,#51,#8B,#4D,#10,#8B,
#45,#0C,#8B,#5D,#08,#F7,#E1,#01,#D8,#03,#45,#14,#59,#5B,#89,#EC,#5D,#C2,#00,#00}

constant has_mmx=define_asm_func(il_code[001..058],{},BYTE,16)  -- mmx func
constant mmx=c_func(has_mmx,{})                                 -- mmx bool

constant params_a=repeat(#02000004,4)   -- argumnet type
constant params_b=repeat(#02000004,5)   -- argumnet type
constant return_a=#02000004             -- argumnet type

sequence
id_code
id_code={}

if mmx then                                                         -- is mmx
    id_code&=define_asm_proc(il_code[059..129],params_a,8)          -- func-a
    id_code&=define_asm_proc(il_code[193..281],params_b,8)          -- func-b
    id_code&=define_asm_proc(il_code[362..438],params_b,8)          -- func-c
    id_code&=define_asm_func(il_code[512..540],params_a,return_a,4) -- func-d
else                                                                -- no mmx
    id_code&=define_asm_proc(il_code[130..192],params_a,4)          -- func-a
    id_code&=define_asm_proc(il_code[282..361],params_b,4)          -- func-b
    id_code&=define_asm_proc(il_code[439..511],params_b,4)          -- func-c
    id_code&=define_asm_func(il_code[512..540],params_a,return_a,4) -- func-d
end if

constant func_a=id_code[1]      --  sprite_tile({spr,dib,out,cnt})
constant func_b=id_code[2]      --  sprite_vesa({spr,dib,x,y,max})
constant func_c=id_code[3]      --  sprite_move({spr,dib,x,y,max})
constant func_d=id_code[4]      --  sprite_addr({x,y,max,dib})

il_code={}                      --  free code data
id_code={}                      --  free code id's

global procedure sprite_tile(sequence x) c_proc(func_a,x) end procedure
global procedure sprite_vesa(sequence x) c_proc(func_b,x) end procedure
global procedure sprite_move(sequence x) c_proc(func_c,x) end procedure
global function  sprite_addr(sequence x) return c_func(func_d,x) end function
